namespace javaCamViewer
{
	using System;
	using System.Drawing;
    using System.IO;

	/// <summary>
	/// IMotionDetector interface
	/// </summary>
	public interface IMotionDetector
    {
        /// <summary>
        /// Debug stream writer object
        /// </summary>
        StreamWriter DebugWriter { set; get; }

		/// <summary>
		/// Motion level calculation - calculate or not motion level
		/// </summary>
		bool MotionLevelCalculation{ set; get; }

		/// <summary>
		/// Motion level - amount of changes in percents
		/// </summary>
		double MotionLevel{ get; }

        /// <summary>
        /// Face detection - use additional processing to detect faces
        /// </summary>
        bool EnableFaceDetection { set; get; }

        /// <summary>
        /// AlertFaceDetected object
        /// </summary>
        EventHandler AlertFaceDetected { set; get; }

		/// <summary>
		/// Process new frame
		/// </summary>
		void ProcessFrame( ref Bitmap image );

		/// <summary>
		/// Reset detector to initial state
		/// </summary>
		void Reset( );
	}
}
